/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.EsquemaTramoDAO;
import com.rjconsultores.ventaboletos.entidad.EsquemaCorrida;
import com.rjconsultores.ventaboletos.entidad.EsquemaTramo;
import com.rjconsultores.ventaboletos.service.EsquemaTramoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Rafius
 */
@Service("esquemaTramoService")
public class EsquemaTramoServiceImpl implements EsquemaTramoService {

    @Autowired
    private EsquemaTramoDAO esquemaTramoDAO;

    public List<EsquemaTramo> obtenerTodos() {
        return esquemaTramoDAO.obtenerTodos();
    }

    public EsquemaTramo obtenerID(Integer id) {
        return esquemaTramoDAO.obtenerID(id);
    }

    @Transactional
    public EsquemaTramo suscribir(EsquemaTramo entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return esquemaTramoDAO.suscribir(entidad);
    }

    @Transactional
    public EsquemaTramo actualizacion(EsquemaTramo entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return esquemaTramoDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(EsquemaTramo entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        esquemaTramoDAO.actualizacion(entidad);
    }

    public List<EsquemaTramo> obtenerPorEsquemaCorrida(EsquemaCorrida ec) {
        return esquemaTramoDAO.obtenerPorEsquemaCorrida(ec);
    }

    public List<EsquemaTramo> obtenerPorEsquemaCorridaOrderNumSec(EsquemaCorrida ec) {
        return esquemaTramoDAO.obtenerPorEsquemaCorridaOrderNumSec(ec);
    }

    public List<EsquemaTramo> obtenerAtivosDesativosPorEsquemaCorrida(EsquemaCorrida esquemaCorrida) {
        return esquemaTramoDAO.obtenerAtivosDesativosPorEsquemaCorrida(esquemaCorrida);
    }
}
